Index: pbx_spool.c
===================================================================
--- pbx_spool.c	(wersja 193458)
+++ pbx_spool.c	(kopia robocza)
@@ -419,20 +419,20 @@
 					return now;
 				} else {
 					ast_log(LOG_EVENT, "Queued call to %s/%s expired without completion after %d attempt%s\n", o->tech, o->dest, o->retries - 1, ((o->retries - 1) != 1) ? "s" : "");
+					remove_from_queue(o, "Expired");
 					free_outgoing(o);
-					remove_from_queue(o, "Expired");
 					return 0;
 				}
 			} else {
-				free_outgoing(o);
 				ast_log(LOG_WARNING, "Invalid file contents in %s, deleting\n", fn);
 				fclose(f);
 				remove_from_queue(o, "Failed");
+				free_outgoing(o);
 			}
 		} else {
-			free_outgoing(o);
 			ast_log(LOG_WARNING, "Unable to open %s: %s, deleting\n", fn, strerror(errno));
 			remove_from_queue(o, "Failed");
+			free_outgoing(o);
 		}
 	} else
 		ast_log(LOG_WARNING, "Out of memory :(\n");
